unit CheckCGC;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    eCGC: TMaskEdit;
    Memo1: TMemo;
    btOK: TButton;
    btSair: TButton;
    procedure btOKClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btSairClick(Sender: TObject);
    procedure eCGCExit(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
  private
    { Private declarations }
    Function FormataCGC(Numero: String):String;
    Function Modulo11CGC(Numero: string):String;
    Function Modulo11CPF(Numero: string):String;
    Function ValidaCGC(Numero: string):Boolean;
    Function ValidaCPF(Numero: string):Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Function TForm1.FormataCGC(Numero: String):String;
begin
  if length(Numero)=11 then
   Result:=copy(numero,1,3)+'.'+copy(numero,4,3)+'.'+copy(numero,7,3)+'-'+copy(numero,10,2);
  if length(Numero)=14 then
   Result:=copy(Numero,1,2)+'.'+copy(numero,3,3)+'.'+copy(numero,6,3)+'/'+copy(numero,9,4)+'-'+copy(numero,13,2);
end;

Function TForm1.Modulo11CGC(Numero: String):String;
var
aPeso: array[1..20] of integer;
aNum:  array[1..20] of integer;
Total,nX,nC,Dv: integer;
begin
  nC:=2;
  Total:=0;
  for nX:=length(Numero) downto 1 do
   begin
    aPeso[nX]:=nC;
    nC:=nC+1;
    if nC > 9 then nC:=2;
   end;
  for nX:=1 to length(Numero) do
   begin
    aNum[nX]:=strtoint(copy(Numero,nX,1));
    Total:=Total+(aNum[nX]*aPeso[nX]);
//  memo1.Lines.Add(inttostr(aNum[nX])+' Peso: '+inttostr(aPeso[nX]))
   end;
  Dv:=(11-(Total mod 11));
  if Dv > 9 then Dv:=0;
  Result:=inttostr(Dv)
end;

Function TForm1.ValidaCGC(Numero: String):Boolean;
var
Dv1,Dv2: string;
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Add('CGC Digitado: '+formataCGC(Numero));
  Dv1:=Modulo11CGC(copy(Numero,1,12));
  Memo1.Lines.Add('1 Dgito Verificador: '+Dv1);
  Dv2:=Modulo11CGC(copy(Numero,1,12)+Dv1);
  Memo1.Lines.Add('2 Dgito Verificador: '+Dv2);
  Memo1.Lines.Add('***** RESULTADO *****');
  Memo1.Lines.Add(' ');
  if (Dv1<>copy(Numero,13,1)) or (Dv2<>copy(Numero,14,1)) then
    begin
     Memo1.Lines.Add('CGC INVLIDO ');
     Memo1.Lines.Add('CGC Correto: '+formataCGC(COPY(Numero,1,12)+Dv1+Dv2));
     Result:=True;
    end
  else
    begin
     Memo1.Lines.Add('CGC VLIDO ');
     Result:=False;
  end;
end;

Function TForm1.Modulo11CPF(Numero: String):String;
var
aPeso: array[1..20] of integer;
aNum:  array[1..20] of integer;
Total,nX,nC,Dv: integer;
begin
  nC:=2;
  Total:=0;
  for nX:=length(Numero) downto 1 do
   begin
    aPeso[nX]:=nC;
    nC:=nC+1;
   end;
  for nX:=1 to length(Numero) do
   begin
    aNum[nX]:=strtoint(copy(Numero,nX,1));
    Total:=Total+(aNum[nX]*aPeso[nX]);
//  memo1.Lines.Add(inttostr(aNum[nX])+' Peso: '+inttostr(aPeso[nX]))
   end;
  Dv:=(11-(Total mod 11));
  if Dv > 9 then Dv:=0;
  Result:=inttostr(Dv);
end;

Function TForm1.ValidaCPF(Numero: String):Boolean;
var
Dv1,Dv2: string;
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Add('CPF Digitado: '+FormataCGC(Numero));
  Dv1:=Modulo11CPF(copy(Numero,1,9));
  Memo1.Lines.Add('1 Dgito Verificador: '+Dv1);
  Dv2:=Modulo11CPF(copy(Numero,1,9)+Dv1);
  Memo1.Lines.Add('2 Dgito Verificador: '+Dv2);
  Memo1.Lines.Add('***** RESULTADO *****');
  Memo1.Lines.Add(' ');
  if (Dv1<>copy(Numero,10,1)) or (Dv2<>copy(Numero,11,1)) then
    begin
     Memo1.Lines.Add('CPF INVLIDO ');
     Memo1.Lines.Add('CPF Correto: '+FormataCGC(COPY(Numero,1,9)+Dv1+Dv2));
     Result:=True;
    end
  else
    begin
     Memo1.Lines.Add('***** CPF VLIDO ');
     Result:=False;
  end;
end;

procedure TForm1.btOKClick(Sender: TObject);
begin
   if length(eCGC.Text)=11 then
     ValidaCPF(trim(eCGC.text))
   else
     ValidaCGC(trim(eCGC.text));
   eCGC.SetFocus;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then
   begin
   key:=#0;
   SelectNext(ActiveControl,True,True);
  end;
end;

procedure TForm1.btSairClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.eCGCExit(Sender: TObject);
begin
   case length(eCGC.text) of
   0:close;
   11:;
   14:;
   else
      Memo1.Lines.Clear;
      Memo1.Lines.Add('NMERO DIGITADO NO  VLIDO');
      Memo1.Lines.Add('O tamanho deve ser de 11 dgitos ou 14.');
      Memo1.Lines.Add('Digite um nmero vlido para sair.');
      eCGC.SetFocus;
   end;
end;

procedure TForm1.Memo1DblClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Add('Sobre o Programa:');
  Memo1.Lines.Add('Autor: Cirilo J. Veloso');
  Memo1.Lines.Add('Email: cjveloso@ig.com.br');
  Memo1.Lines.Add('Revisao: Criado em Fev/2000');
end;

end.
